clc
P=load('normal.txt'); 
load('pipe1.mat');
P1=pipe1;
%P1=load('pipe1.txt');
nx=length(P1);

%P1=load('pipe1.txt');
nn=length(P1);
n=length(P);
Normal_x=P(1:n,1);
Normal_y=P(1:n,2);
Normal_z=P(1:n,3);
A=zeros(2,2);
b=zeros(2,1);
for i=1:n
 A(1,1)=A(1,1)+Normal_x(i)*Normal_x(i);
 A(1,2)=A(1,2)+Normal_x(i)*Normal_y(i);
  A(2,1)=A(2,1)+Normal_x(i)*Normal_y(i);
 % A(1,3)=A(1,3)+Normal_x(i)*Normal_z(i);
   A(2,2)=A(2,2)+Normal_y(i)*Normal_y(i);
   b(1)=b(1)+Normal_x(i)*Normal_z(i);
   b(2)=b(2)+Normal_y(i)*Normal_z(i);
   % A(2,3)=A(2,3)+Normal_z(i)*Normal_y(i);
   %  A(3,3)=A(3,3)+Normal_z(i)*Normal_z(i);
end
b(1)=-b(1);
b(2)=-b(2);
%A(3,1)=A(1,3);
%A(3,2)=A(2,3);
x=A\b;
Plane=zeros(4,1);
Plane(1)=x(1);
Plane(2)=x(2);
Plane(3)=1;
Plane(4)=0;
dd=zeros(nn,1);

for i=1:nn
dd(i)=abs(Plane(1)*P1(i,1)+Plane(2)*P1(i,2)+Plane(3)*P1(i,3)+Plane(4))/sqrt(Plane(1)^2+Plane(2)^2+Plane(3)^2);
end

P2=zeros(nn,3);
Normal=[Plane(1),Plane(2),Plane(3)];
for i=1:nn
choice1=P1(i,:)+dd(i)*Normal/sqrt(Plane(1)^2+Plane(2)^2+Plane(3)^2);
choice2=P1(i,:)-dd(i)*Normal/sqrt(Plane(1)^2+Plane(2)^2+Plane(3)^2);
if abs(Plane(1)*choice1(1)+Plane(2)*choice1(2)+Plane(3)*choice1(3)+Plane(4))>abs(Plane(1)*choice2(1)+Plane(2)*choice2(2)+Plane(3)*choice2(3)+Plane(4))
P2(i,:)=choice2;
else
  P2(i,:)=choice1;  
end
end    

l=Plane(1)/sqrt(Plane(1)*Plane(1)+Plane(2)*Plane(2)+Plane(3)*Plane(3));
m=Plane(2)/sqrt(Plane(1)*Plane(1)+Plane(2)*Plane(2)+Plane(3)*Plane(3));
n=Plane(3)/sqrt(Plane(1)*Plane(1)+Plane(2)*Plane(2)+Plane(3)*Plane(3));

R=[1-l^2/(1+n),-l*m/(1+n),-l;-l*m/(1+n),1-m^2/(1+n),-m;l,m,n]; 
P3=(R*P1')';

X=[P3(:,1),P3(:,2)];
y=zeros(nn,1);
bb=[rand(1)*100 rand(1) rand(1)];
fun=inline('X(:,1).^2+X(:,2).^2+a(1)*X(:,1)+a(2)*X(:,2)+a(3)','a','X');
a=nlinfit(X,y,fun,bb);
X1=-a(1)/2;
Y1=-a(2)/2;
R0=sqrt(a(1)^2+a(2)^2-4*a(3))/2;
Z1=sum(P3(:,3))/nn;
Center0=R\[X1;Y1;Z1];
X0=Center0(1);
Y0=Center0(2);
Z0=Center0(3);
P1=1000*P1;
X0=1000*X0;
Y0=1000*Y0;
Z0=1000*Z0;
R0=1000*R0;

syms u v x0 z0 y0 r0 f xt yt zt;
f=sqrt((u*(yt-y0)-v*(xt-x0))^2+(u*(zt-z0)-(xt-x0))^2+(v*(zt-z0)-(yt-y0))^2)/sqrt(1+u*u+v*v)-r0;

f_init=0;
for i=1:nn
f_init=f_init+subs(f^2,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),Plane(1),Plane(2),X0,Y0,Z0,R0});
end

Ndata=nn;
Nparams=4;
n_iters=10;
lamda=0.01;
% step1Assignment of variables

updateJ=1;
u_est=Plane(1);
v_est=Plane(2);
x0_est=X0;
y0_est=Y0;
r0_est=R0;

% step2: iteration

for it=1:n_iters
    if updateJ==1
        J=zeros(Ndata,Nparams);
        for i=1:nn
            J(i,1)=subs(diff(f,u),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
            J(i,2)=subs(diff(f,v),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
            J(i,3)=subs(diff(f,x0),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
            J(i,4)=subs(diff(f,y0),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
        end
       
         y_est=zeros(nn,1);
        for i=1:nn
        y_est(i,1) = subs(f,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
        end
        
        d=-y_est;
        H=J'*J;
        if it==1
            e=dot(d,d);
        end
    end

    H_lm=H+(lamda*eye(Nparams,Nparams));
    dp=inv(H_lm)*(J'*d(:));
    g = J'*d(:);
    u_lm=u_est+dp(1);
    v_lm=v_est+dp(2);
    x0_lm=x0_est+dp(3);
    y0_lm=y0_est+dp(4);
  %  if sqrt(dp(1)^2+dp(2)^2+dp(3)^2+dp(4)^2)<0.01
   %     break;
    %end
    if norm(g)<0.00001
        break;
    end
   
    r0_est_lm=0;
    for k=1:nn
       r0_est_lm=r0_est_lm+sqrt((u_lm*(P1(k,2)-y0_lm)-v_lm*(P1(k,1)-x0_lm))^2+(u_lm*(P1(k,3)-Z0)-(P1(k,1)-x0_lm))^2+(v_lm*(P1(k,3)-Z0)-(P1(k,2)-y0_lm))^2)/sqrt(1+u_lm*u_lm+v_lm*v_lm);
    end
    r0_est_lm=r0_est_lm/nn;
    y_est_lm=zeros(nn,1);
    for i=1:nn
    y_est_lm(i,1) =subs(f,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_lm,v_lm,x0_lm,y0_lm,Z0,r0_est_lm});
    end
    d_lm=-y_est_lm;
    e_lm=dot(d_lm,d_lm);
    if e_lm<e     
        lamda=lamda/10;
         disp(sqrt(dp(1)^2+dp(2)^2+dp(3)^2+dp(4)^2));
        u_est=u_lm;
        v_est=v_lm;
         x0_est=x0_lm;
          y0_est=y0_lm;
          r0_est=r0_est_lm;
        e=e_lm;
      %  disp(e);
        updateJ=1;
    else
        updateJ=0;
        lamda=lamda*10;
    end
end   
   
if subs(f,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(1,1),P1(1,2),P1(1,3),u_est,v_est,x0_est,y0_est,Z0,r0_est})<0
d_min=subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(1,1),P1(1,2),P1(1,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
d_max=0;
else
    d_max=subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(1,1),P1(1,2),P1(1,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
    d_min=0;
end
d_avra=subs(f,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(1,1),P1(1,2),P1(1,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
for i=2:nn
    if subs(f,{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est})<0
    if d_min<subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est})
      d_min=subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
     end
    else
         if d_max<subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est})
          d_max=subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
          end
    end
d_avra=d_avra+subs(abs(f),{xt,yt,zt,u,v,x0,y0,z0,r0},{P1(i,1),P1(i,2),P1(i,3),u_est,v_est,x0_est,y0_est,Z0,r0_est});
end
d_avra=d_avra/nn;